﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using InternshipSystem.Api.Security;
using InternshipSystem.Repository;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace InternshipSystem.Api.Controllers
{
    [ApiController]
    [Route("management/course")]
    public class CourseController : ControllerBase
    {
        private InternshipDbContext Context { get; }
        
        public CourseController(InternshipDbContext context)
        {
            Context = context;
        }

        [HttpGet]
        [Authorize(Policy = Policies.IsOverseer)]
        public async Task<ActionResult<IReadOnlyCollection<CourseResult>>> GetCourses(CancellationToken cancellationToken) =>
            throw new NotImplementedException();
        
        [HttpGet("{courseId}")]
        [Authorize(Policy = Policies.IsOverseer)]
        public async Task<ActionResult<CourseResult>> GetCourse(long courseId, CancellationToken cancellationToken) =>
            throw new NotImplementedException();
        
        [HttpPut]
        [Authorize(Policy = Policies.IsOverseer)]
        public async Task<ActionResult> UpsertCompany([FromBody] CourseForm courseForm, CancellationToken cancellationToken) =>
            throw new NotImplementedException();
        
        [HttpDelete("{courseId}")]
        [Authorize(Policy = Policies.IsOverseer)]
        public async Task<ActionResult> DeleteCompany(long courseId, CancellationToken cancellationToken) =>
            throw new NotImplementedException();
    }

    public class CourseForm
    {
    }

    public class CourseResult
    {
    }
}